#!/usr/bin/env python2.3
#
#   mibcip - Modular IRC Bot Core In Python
#   Copyright (C) 2004  Helmut Grohne
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

from ConfigParser import ConfigParser

conflicts = []
depends = []

class plugin:
    """Provide an interface to the configuration file. API: stable."""
    def __init__(self, base):
        self.cp = ConfigParser()
        self.cp.read(base.configfile)

    def __getstate__(self):
        """This is method is to reconstruct the instance. Do not use with
        pickle."""
        return None

    def __setstate__(self, state):
        """This is method is to reconstruct the instance. Do not use with
        pickle."""

    def has_plugin(self, plugin):
        """Check if there is a section for given plugin."""
        return self.cp.has_section(plugin)

    def has_option(self, plugin, option):
        """Check if given option is set for given plugin."""
        return self.cp.has_option(plugin, option)

    def options(self, plugin):
        """Returns a list of options set for given plugin."""
        return self.cp.options(plugin)

    def get(self, plugin, option, raw=False, vars=None):
        """Get an option for given plugin. For more details see documentation
        on ConfigParser.ConfigPArser.get."""
        return self.cp.get(plugin, option, raw, vars)

    def getint(self, plugin, option):
        """Get an option as int for given plugin."""
        return self.cp.getint(plugin, option)

    def getfloat(self, plugin, option):
        """Get an option as float for given plugin."""
        return self.cp.getfloat(plugin, option)

    def getbool(self, plugin, option):
        """Get an option as bool for given plugin. For more details see
        documentation on ConfigParser.ConfigParser.getbool."""
        return self.cp.getbool(plugin, option)

    def items(self, plgn, raw=False, vars=None):
        """Returns a list of options and values for given plugin. For more
        details see documentation on ConfigParser.ConfigParser.items."""
        return self.cp.items(plgn, raw, vars)
