#!/usr/bin/env python2.3
#
#   mibcip - Modular IRC Bot Core In Python
#   Copyright (C) 2004  Helmut Grohne
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

import random

rand = random.Random()

conflicts = []
depends = [ ["core.event"], ["core.parser"], ["core.config"], ["core.cmd"],
            ["core.info"] ]

class plugin:
    def __init__(self, base):
        self.base = base
        filename = base.p.core.config.get("test.bofh", "filename")
        self.excuses = map(str.strip, open(filename, "r").readlines())
        base.p.core.event.attach_event("core.parser", "test.bofh",
                                       "PRIVMSG", self.cmd_bofh)

    def __getstate__(self):
        return None

    def __setstate__(self, state):
        pass

    def cmd_bofh(self, (nick, chan, text)):
        # TODO: move this to attach_event
        if text != '!bofh':
            return
        if self.base.p.core.info.isself(nick):
            return
        privmsg = self.base.p.core.cmd.privmsg
        if self.base.p.core.servcapab.ischannel(chan):
            privmsg(chan, "%s: %s" % (nick, rand.choice(self.excuses)))
        else:
            privmsg(nick, rand.choice(self.excuses))

