#!/usr/bin/env python2.3
#
#   mibcip - Modular IRC Bot Core In Python
#   Copyright (C) 2004  Helmut Grohne
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

import time

conflicts = []
depends = [ ["core.config"], ["core.event"], ["core.parser"], ["core.info"],
            ["core.cmd"] ]

class plugin:
    def __init__(self, base):
        self.base = base
        self.version = base.p.core.config.get("test.ctcp", "version")
        base.p.core.event.attach_event("core.parser", "test.ctcp",
                                       "CTCPREQ", self.on_ctcpreq)

    def __getstate__(self):
        return None

    def __setstate__(self, state):
        pass

    def on_ctcpreq(self, (nick, target, text)):
        if self.base.p.core.info.isself(nick):
            return
        try:
            command, args = text.split(" ",1)
        except ValueError:
            command = text
            args = ""
        else:
            args = " %s" % args

        ctcprep = self.base.p.core.cmd.ctcprep
        if command == "PING":
            ctcprep(nick, command + args)
        elif command == "VERSION" and not args:
            ctcprep(nick, "%s %s" % (command, self.version))
        elif command == "TIME" and not args:
            ctcprep(nick, "%s %s" % (command, time.asctime()))
