#!/usr/bin/env python2.3
#
#   mibcip - Modular IRC Bot Core In Python
#   Copyright (C) 2004  Helmut Grohne
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

conflicts = []
depends = [ ["core.event"], ["core.parser"], ["core.info"], ["core.send"],
            ["core.cmd"], ["core.send"] ]

class plugin:
    def __init__(self, base):
        self.base = base
        self.inb = 0
        self.outb = 0
        attach_event = base.p.core.event.attach_event
        attach_event("core.parser", "test.debug", "PRIVMSG", self.debug)
        attach_event("core.event", "test.debug", "data", self.data_in)
        attach_event("core.send", "test.data", "data", self.data_out)

    def __getstate__(self):
        return None

    def __setstate__(self, state):
        return None

    def data_in(self, (data,)):
        self.inb += len(data)

    def data_out(self, (data,)):
        self.outb += len(data)

    def cmd_debug(self, text):
        info = self.base.p.core.info
        tokens = (info.timedelta, info.myinf, info.users.values(),
                  info.chans.values())
        text = ", ".join(map(repr, tokens))
        print "DEBUG DEBUG:", ", ".join(map(repr, tokens))
        if len(text) > 512:
            return ""
        return text

    def cmd_raw(self, text):
        text = text[4:].strip()
        send = self.base.p.core.send
        send.quote(text, send.IDL)
        return text

    def cmd_reload(self, text):
        text = text[7:].strip()
        if text in self.base.plugins:
            return repr(self.base.reload(text))
        return "failed"

    def cmd_eval(self, text):
        try:
            return repr(eval(text[5:].strip()))
        except Exception, e:
            return "failed: %r" % e
        except:
            return "failed"

    def cmd_io(self, text):
        return "%s bytes in and %s bytes out" % (self.inb, self.outb)

    def debug(self, (nick, chan, text)):
        if not self.base.p.core.auth.auth_level(nick):
            return
        # TODO: move this to attach_event
        dct = {'debug': self.cmd_debug,
               'raw': self.cmd_raw,
               '!io': self.cmd_io,
               'reload': self.cmd_reload}
        if self.base.p.core.auth.auth_level(nick) >= 10:
            dct["eval"] = self.cmd_eval
        if text.split(" ")[0] not in dct:
           return
        if self.base.p.core.info.isself(nick):
            return
        msg = dct[text.split(" ")[0]](text)
        cmd = self.base.p.core.cmd
        if self.base.p.core.servcapab.ischannel(chan):
            cmd.privmsg(chan, "%s: %s" % (nick, msg))
        else:
            cmd.privmsg(nick, msg)

