#!/usr/bin/env python2.3
#
#   mibcip - Modular IRC Bot Core In Python
#   Copyright (C) 2004  Helmut Grohne
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

conflicts = []
depends = [ ["core.event"], ["core.parser"], ["core.config"], ["core.cmd"] ]

class plugin:
    def __init__(self, base):
        self.base = base
        self.base.p.core.event.attach_event("core.parser", "test.nickserv",
                                            "PNOTICE", self.on_notice)

    def __getstate__(self):
        return None

    def __setstate__(self, state):
        pass

    def haspassword(self):
        return self.base.p.core.config.has_option("test.nickserv", "password")

    def getpassword(self):
        return self.base.p.core.config.get("test.nickserv", "password")

    def on_notice(self, (nick, target, text)):
        if nick.lower() != "nickserv":
            return
        p = text.find("msg")
        if p < 0: return
        p = text.find("NickServ", p+1)
        if p < 0: return
        p = text.find("IDENTIFY", p+1)
        if p < 0: return
        # this is the key message :)
        if not self.haspassword(): return
        privmsg = self.base.p.core.cmd.privmsg
        privmsg(nick, "IDENTIFY %s" % self.getpassword())
