#!/usr/bin/env python2.3
#
#   mibcip - Modular IRC Bot Core In Python
#   Copyright (C) 2004  Helmut Grohne
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

conflicts = []
depends = [ ["core.event"], ["core.parser"], ["core.auth"], ["core.info"] ]

class plugin:
    def __init__(self, base):
        self.base = base
        self.auth = {}
        base.p.core.auth.register_method("password", self.auth_password)
        base.p.core.event.attach_event("core.parser", "test.password",
                                       "PRIVMSG", self.on_privmsg)

    def __getstate__(self):
        return self.auth

    def __setstate__(self, state):
        self.auth = state

    def auth_password(self, nick, arg):
        self.auth[nick] = arg

    def on_privmsg(self, (nick, target, text)):
        if self.base.p.core.info.isself(nick):
            return
        try:
            command, args = text.split(" ",1)
        except ValueError:
            # No args? Can't be valid.
            return

        if command.lower() != 'identify':
            return

        args = args.split(" ",1)
        if len(args) != 2:
            # No password? Can't be valid.
            print "AUTH:PASSWORD:no password"
            return

        # Try to login.
        self.base.p.core.auth.login(nick, args[0])

        if nick not in self.auth:
            # No such nick? Stop.
            print "AUTH:PASSWORD:no nick"
            return

        self.base.p.core.auth.report("password", self.auth[nick], nick,
                                     args[1] == self.auth[nick])
