#!/usr/bin/env python2.3
#
#   mibcip - Modular IRC Bot Core In Python
#   Copyright (C) 2004  Helmut Grohne
#
#   This program is free software; you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation; either version 2 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#

import re
import time

urlmatcher = re.compile(
             "(?:https?|ftp)?://[a-zA-Z0-9.-]+(?::[0-9]+)?(?:/[^ \"]*)?")

def time_str():
    return time.strftime("%H:%M", time.localtime(time.time()))

conflicts = []
depends = [ ["core.config"], ["core.event"], ["core.parser"] ]

class plugin:
    def __init__(self, base):
        self.filename = base.p.core.config.get("test.urllog", "filename")
        self.logfile = file(self.filename, "a")
        base.p.core.event.attach_event("core.parser", "test.log", "PRIVMSG",
                                       self.on_privmsg)

    def writelog(self, msg):
        self.logfile.write("%s %s\n" % (time_str(), msg))
        self.logfile.flush()

    def on_privmsg(self, (nick, target, text)):
        global urlmatcher
        for u in urlmatcher.findall(text):
            self.writelog("%s: %s" % (nick, u))

    def __getstate__(self):
        return None

    def __setstate__(self, state):
        pass
